<?php

//$Id: licensing.views.inc,v 1.1 2009/12/01 03:33:26 nickurbits Exp $

/**
 * @file
 *  Contains:
 *   - Views 2 API Implementation
 *
 * Contains views 2.x hooks
 */

/**
 * Implement hook_views_handlers
 */
function licensing_views_handlers() {
  return array(
    'info' => array(
      'path' => drupal_get_path('module', 'licensing') . '/views/handlers',
    ),
    'handlers' => array(
      'views_handler_field_license_id' => array(
        'parent' => 'views_handler_field',
      ),
      'views_handler_field_boolean_license_key' => array(
        'parent' => 'views_handler_field_boolean',
      ),
    ),
  );
}

/**
 * Implement hook_views_data
 */
function licensing_views_data() {

  $data['licensing_key']['table']['group'] = t('Licensing');

  $data['licensing_key']['table']['base'] = array(
    'field' => 'lid',
    'title' => t('License key'),
    'help' => t('License schema provided by licensing module.'),
    'weight' => 0,
  );

  $data['licensing_key']['lid'] = array(
    'title' => t('License Id'),
    'help' => t('The primary identifier for license keys.'),
    'field' => array(
      'handler' => 'views_handler_field_license_id',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument',
    ),
  );

  $data['licensing_key']['license'] = array(
    'title' => t('License key'),
    'help' => t('The unique license key.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument',
    ),
  );

  $data['licensing_key']['uid'] = array(
    'title' => t('User Id'),
    'help' => t('The identifier for the user of the license key.'),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'users',
      'base field' => 'uid',
      'relationship field' => 'uid',
      'label' => t('License key user'),
    ),
  );

  $data['licensing_key']['shelf'] = array(
    'title' => t('Status'),
    'help' => t('The boolean status of a license key.'),
    'field' => array(
      'handler' => 'views_handler_field_boolean_license_key',
      'type' => 'used-unused',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_boolean_operator',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );

  return $data;
}
